/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.translation.ui.actions;

import java.util.Iterator;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWTError;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;

import benten.cat.translation.ui.tmengine.ITmEntry;
import benten.cat.translation.ui.views.TranslationView;

public class CopyTranslatinAction extends Action {

	private TranslationView view;

	public CopyTranslatinAction(TranslationView view, String text) {
		super(text);
		this.view = view;
	}

	public void run() {

		IStructuredSelection selection = (IStructuredSelection) view.getSelection();
		if (selection.size() == 0) {
			return;
		}
		try {
			view.getClipBoard().setContents(new Object[] { asText(selection) },
					new Transfer[] { TextTransfer.getInstance() });
		} catch (SWTError error) {

		}
	}

	private static String asText(IStructuredSelection selection) {

		Iterator<?> itr = selection.iterator();
		ITmEntry entry = (ITmEntry) itr.next();
		StringBuffer result = new StringBuffer();
		result.append("<source>");
		result.append(entry.getSrcText());
		result.append("</source>");
		result.append("\n");
		result.append("<target>");
		result.append(entry.getTranslation());
		result.append("</target>");
		result.append("\n");
		return result.toString();
	}
}
